﻿@page "/account"

@using FIOAPIWeb.Components.Account

@inject ClipboardService Clipboard
@inject UserAppState UserAppState
@inject ISnackbar Snackbar
@inject IDialogService DialogService

@implements IDisposable

<LoadingWrapper RequiresAuth="true" @bind-ProgressCount="@CurrentProgress" TotalProgress="@TotalProgress">
    <MudText Typo="Typo.h5">User Reset</MudText>
    <MudText Typo="Typo.caption">
        This will reset data specific for your user.<br />
        Use this if you have some bad data or if you COLIQ'd.<br />
        You should do a <MudLink Href="/setup" Typo="Typo.caption">setup</MudLink> again after resetting.<br />
    </MudText>
    <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Secondary" OnClick="ResetDataAsync">Reset Data</MudButton>

    <br />
    <br />
    <MudDivider DividerType="DividerType.Middle" />

    <MudText Typo="Typo.h5">Change Password</MudText>
    <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" OnClick="ChangePasswordAsync">Change Password</MudButton>

    <br />
    <br />
    <MudDivider DividerType="DividerType.Middle" />

    <MudText Typo="Typo.h5">Discord Name</MudText>
    
    <MudText Typo="Typo.caption">
        @if (!string.IsNullOrEmpty(UserAppState.DiscordName))
        {
            @($"Your discord name is currently set to '{UserAppState.DiscordName}'.")
        }
        else
        {
            @("Your discord name is currently unset.")
        }
        <br />
    </MudText>
    <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" OnClick="SetDiscordNameAsync">Set Discord Name</MudButton>

    <br />
    <br />
    <MudDivider DividerType="DividerType.Middle" />

    <MudText Typo="Typo.h5">API Keys</MudText>
    <MudButton Size="Size.Small" 
               Variant="Variant.Filled" 
               Color="Color.Primary"
               OnClick="CreateAPIKey">Create API Key</MudButton>
    <MudTable Items="@APIKeys"
              Dense="true"
              Bordered="true"
              HorizontalScrollbar="true"
              Breakpoint="Breakpoint.Sm">
        <HeaderContent>
            <MudTh />
            <MudTh>Application</MudTh>
            <MudTh>APIKey</MudTh>
            <MudTh>Write</MudTh>
            <MudTh />
        </HeaderContent>
        <RowTemplate>
            <MudTd>
                <MudFab Color="Color.Primary" Size="Size.Small" StartIcon="@Icons.Material.Filled.ContentCopy" OnClick="@(() =>CopyAPIKeyToClipboard(@context))" />
            </MudTd>
            <MudTd DataLabel="Application">
                @context.Application
            </MudTd>
            <MudTd DataLabel="APIKey">
                @context.Key
            </MudTd>
            <MudTd DataLabel="AllowWrites">
                <MudCheckBox Value="@context.AllowWrites" Dense="true" ReadOnly="true" Color="Color.Primary" />
            </MudTd>
            <MudTd>
                <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Secondary" OnClick="@(() => DeleteAPIKey(@context.Key))">Delete</MudButton>
            </MudTd>
        </RowTemplate>
        <PagerContent>
            <MudTablePager PageSizeOptions="new int[] { 5, 10, 20 }"/>
        </PagerContent>
    </MudTable>

    <br />
    <br />
    <MudDivider DividerType="DividerType.Middle" />

    <MudText Typo="Typo.h5">Groups</MudText>
    <MudText Typo="Typo.caption">Create up to 10 groups that you can share with others.<br /></MudText>
    <MudButton Size="Size.Small"
               Variant="Variant.Filled"
               Color="Color.Primary"
               OnClick="CreateGroup">Create Group</MudButton>
    <MudTable Items="@UserAppState.Groups"
              Dense="true"
              Bordered="true"
              Breakpoint="Breakpoint.Sm">
        <HeaderContent>
            <MudTh>Group Id</MudTh>
            <MudTh>Group Name</MudTh>
            <MudTh>Owner</MudTh>
            <MudTh>Admin</MudTh>
            <MudTh />
            <MudTh />
            <MudTh />
        </HeaderContent>
        <RowTemplate>
            <MudTd DataLabel="GroupId">
                @context.GroupId
            </MudTd>
            <MudTd DataLabel="GroupName">
                @context.GroupName
            </MudTd>
            <MudTd>
                @context.GroupOwner
            </MudTd>
            <MudTd>
                <MudCheckBox Value="@(AmIAdmin(context))" Dense="true" ReadOnly="true" Color="Color.Primary" />
            </MudTd>
            <MudTd>
                <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" Disabled="@(!AmIOwner(context))" OnClick="@(() => InviteAdmins(@context.GroupId))">Invite Admin</MudButton>
            </MudTd>
            <MudTd>
                <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Primary" Disabled="@(!AmIAdmin(context))" OnClick="@(() => InviteMembers(@context.GroupId))">Invite Member</MudButton>
            </MudTd>
            <MudTd>
                <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Secondary" Disabled="@(!AmIOwner(context))" OnClick="@(() => DeleteGroup(@context.GroupId))">Delete</MudButton>
            </MudTd>
        </RowTemplate>
        <PagerContent>
            <MudTablePager PageSizeOptions="new int[] { 5, 10 }"/>
        </PagerContent>
    </MudTable>

    <br />
    <br />
    <MudDivider DividerType="DividerType.Middle" />

    <MudText Typo="Typo.h5">Permissions</MudText>
    <MudText Typo="Typo.caption">Add individual permissions on a per-user basis. Group permissions are inferred by that group's permission.</MudText>
    <MudText Typo="Typo.caption">A username of "*" indicates <b>all</b> users, so you can make your data to all FIO users if you wish.</MudText>
    <br/>
    <MudButton Size="Size.Small"
               Variant="Variant.Filled"
               Color="Color.Primary"
               OnClick="CreatePermission">Create Permissions</MudButton>
    <MudTable Items="@PermissionsGranted"
              Dense="true"
              Bordered="true"
              Breakpoint="Breakpoint.Sm">
        <HeaderContent>
            <MudTh>UserName</MudTh>
            <MudTh>Permissions</MudTh>
            <MudTh />
        </HeaderContent>
        <RowTemplate>
            <MudTd DataLabel="UserName">
                @context.GranteeUserName
            </MudTd>
            <MudTd DataLabel="Permissions">
                <EditPermissionsExpander UserName="@context.GranteeUserName" @bind-Perms="@context.Permissions" />
            </MudTd>
            <MudTd>
                <MudButton Size="Size.Small" Variant="Variant.Filled" Color="Color.Secondary" OnClick="@(() => DeletePermission(@context.GranteeUserName))">Delete</MudButton>
            </MudTd>
        </RowTemplate>
        <PagerContent>
            <MudTablePager PageSizeOptions="new int[] { 5, 10, 20 }" />
        </PagerContent>
    </MudTable>
</LoadingWrapper>